var mraa = require('mraa');
var server = require('http').createServer();
var io = require('socket.io').listen(server);

var port = 1234;

var hx711 = require('jsupm_hx711');// Instantiate a HX711 data on digital pin D3 and clock on digital pin D2

// Intel Edison mapping
var DATA_SHIELD = 50;//50;   // 50   J20 - pin 9 GP42 SSP2_RXD GPIO, SSP2 Rx data input. 50	J20-9	GP42		GPIO-42	SSP2_RXD
var CLOCK_SHIELD = 52;//52;  // 52	J20-11	GP78		GPIO-78	SD


//10	J17-11	GP109		GPIO-109	SPI-5-SCK	
//11	J17-12	GP115		GPIO-115	SPI-5-MOS

// MRAA mapping
//var DATA_MRAA = 53; // GPIO block GP12
//var CLOCK_MRAA = 52; // GPIO block GP128


var scale = new hx711.HX711(DATA_SHIELD, CLOCK_SHIELD);



var calibrationFactor = 311; 

// 1. scale.setScale();
// 2. scale.tare();
// 3. scale.getUnits(); von bekanntem objekt <--ergebnis durch bekanntes gewicht. ~28000 / 81 ~ 345


console.log("... call setScale()" +scale.read());
console.log("... call setScale()");
    

    scale.setScale();
    
    console.log("... call tare()");
    scale.tare();
    console.log("... sleep");
    sleep(5000);

    
    var zeroFactor = scale.readAverage(10); // Get a baseline reading
    console.log("Zero factor: " + zeroFactor+" getunits: "+scale.getUnits()); //This can be used to remove the need to tare the scale. Useful in permanent scale projects.
    
    console.log("Put a known weight on the scale at this time..")



scale.setScale(calibrationFactor); //This value is obtained by using the SparkFun_HX711_Calibration sketch 

//https://github.com/intel-iot-devkit/upm/blob/master/examples/javascript/hx711.js

setTimeout(function(){
    // 2837: value obtained via calibration
   
    //scale.tare();
    setInterval(function(){
     //   if(scale.getUnits()<81){
     //       calibrationFactor--;
     //   }
     //   scale.setScale(calibrationFactor);

        console.log("get units: " + scale.getUnits()  + " faktor: " + calibrationFactor);
    }, 1000);
}, 1000);



io.on('connection', function(socket) {
    console.log("A client is connected!");
    
    socket.on('disconnect', function () {
        socket.disconnect();
        console.log("A client is disconnected!");
    });
    
    socket.on('mv1', function() {
       
        
        
        calibrationFactor += 10.0;  
        scale.setScale(calibrationFactor); //Adjust to this calibration factor
        var units = scale.getUnits();
        
        //Change this to kg and re-adjust the calibration factor if you follow SI units like a sane person
        console.log("Reading: " + units + " g calibration factor: " + calibrationFactor);
        
        
    });
    
    socket.on('mv2', function() {
        
        calibrationFactor -= 10.0;
        
        scale.setScale(calibrationFactor); //Adjust to this calibration factor
        var units = scale.getUnits();
        
        //Change this to kg and re-adjust the calibration factor if you follow SI units like a sane person
        console.log("Reading: " + units + " g calibration factor: " + calibrationFactor);
         
    });
    
    socket.on('mv3', function() {

       
        
    });
    
    socket.on('mv4', function() {
        
    
   
        
    });

});

server.listen(port, function() {
    console.log("Server listening on port " + port);
});


function sleep(milliseconds) {
  var start = new Date().getTime();
  for (var i = 0; i < 1e7; i++) {
    if ((new Date().getTime() - start) > milliseconds){
        break;
    }
  }
}

